; REV 1.0	NOV 16,2016 AUTHOR RICHARD MAIN
; REV 1.1	JAN 22,2018 J. MCMULLEN
;	RENAMED TO IMAGER TO BETTER IDENTIFY WHAT IT DOES
;	IN RELATIONSHIP TO IS COUNTERPART CREATR WHICH MAKES THE DISK
;	FROM THE IMAGE THIS UTILITY CREATES
;	- CHANGED DISK DRIVE TO BE IMAGED FROM F1 TO F3
;
; IMAGE COMMAND IN ISIS-II TO TRANSFER IMAGE OF WHOLE
; DISK F3 TO USB. USE "IMAGER NEWFILE.IMG" FOR EXAMPLE.
; TAKES ABOUT TEN MINUTES TO COMPLETE AND A 0-76 COUNTER
; ON SCREEN SHOWS TRACK-BY-TRACK PROGRESS.
;
; CHANGE DISK BY CHANGING "OPCODE:" IN THE IOPB: AS FOLLOWS*
;	DISK 0 = 04H
;	DISK 1 = 14H
;	DISK 2 = 24H
;	DISK 3 = 34H
;
; THIS UTILITY EXPECTS RICHARD MAIN'S 8251 MODIFICATION TO THE TTY USART
; AT TTY USART SOCKET A91 OF IPC WHICH COMPLETELY BYPASSES ALL TTY INTERFACING.
; ALSO REQUIRED IS THE HOBBYTRONICS USB HOST ADAPTER WITH THE USB FLASH
; READ/WRITE FIRMWARE VERSION 1.14.
;
CR	EQU	0DH
LF	EQU	0AH
;
; ISIS CALLS
;
OPEN	EQU	0
CLOSE	EQU	1
READ	EQU	3
WRITE	EQU	4
EXIT	EQU	9
ERROR	EQU	12
;
OPCPL	EQU	4
DSTS	EQU	78H
DTYPE	EQU	79H
RSTS	EQU	7BH
LOWW	EQU	79H
HI	EQU	7AH
DSKRST	EQU	7FH
;
CRTI	EQU	0F6H	; MDS SERIAL CHANNEL 2
CRTO	EQU	0F6H
CRTS	EQU	0F7H
CRTC	EQU	0F7H
CRTD	EQU	0F6H
;
TTYI	EQU	0F4H	; MDS SERIAL CHANNEL 1, OBSOLETE WITH TTY INTERFACE
TTYO	EQU	0F4H
TTYS	EQU	0F5H
TTYC	EQU	0F5H
TTYD	EQU	0F4H
;
TRDY	EQU	00000001B
RRDY	EQU	00000010B
;
DTR	EQU	00000010B
;
	EXTRN	ISIS	; EXTERNAL REFERENCES TO ISIS-II SYSTEM AND MDS CONSOLE
	EXTRN	CO
	EXTRN	CI
;
	CSEG
;
;
; SET THE TIMER CH0 AND TTY USART TO OPERATE AT 9600 BAUD
;
IMAGER:
	MVI	A,040H	; RESET THE USART
	OUT	TTYC
;
	MVI	A,036H	; SELECT COUNTER 0, R/L LSB-MSB, SQ WV GEN
	OUT	0F3H	; MODE 3 AND LSB FOLLOWED BY MSB
;
	LXI	H,08H	; FOR 9600 BAUD
	MOV	A,L
	OUT	0F0H	; SEND TO THE TIMER FOR TTY USART CH0
	MOV	A,H
	OUT	0F0H
;
	MVI	A,0CEH	; MULTIPLIER FOR 9600 BAUD
	OUT	TTYC
	MVI	A,025H	; ENABLE TX, RX, AND RTS
	OUT	TTYC
;
	LXI	SP,STCKA+4	; OUR OWN USER STACK AREA
	MVI	A,35H	; PUT DTR AND SD0 USB HIGH
	OUT	TTYC
;
; TTY INTERFACE TO USB FLASHDRIVE READY TO GO AT 9600 BAUD
;
MSG:
	LXI	H,HELLO
MSG1:
	MOV	A,M
	ORA	A
	JZ	GETFN	; DONE WITH MESSAGE, DO THE JOB
	MOV	C,A
	CALL	CO	; MESSAGE TO CONSOLE OUTPUT
	INX	H	; POINT TO NEXT CHARACTER
	JMP	MSG1
;
HELLO:	DB	'MDS DISK F3 IMAGING TO USB STICK UTILITY',CR,LF
	DB	'VERS 1.1 JAN 23, 2018',CR,LF
	DB	'USAGE: IMAGE <FILENM.IMG>',CR,LF,LF,0
;

GETFN:	MVI	C,READ		; GET THE FILENAME TO USER INDICATED
	LXI	D,RBLK
	CALL	ISIS
	LDA	STATUS
	ORA	A
	JNZ	ERR
;
	LXI	H,BUFFER
	LXI	D,FILENM
	MVI	C,128
MOVEIT:				; EXTRACT THE FILENAME AND SAVE IT
	MOV	A,M
	INX	H
	STAX	D
	INX	D
	MOV	A,M		; PARSE IT
	CPI	20H
	JZ	ZERO
	CPI	CR
	JZ	ZERO
	DCR	C
	JZ	ZERO
	JMP	MOVEIT
;
ZERO:	MVI	A,0		; MARK FILENAME END
	STAX	D
;
	LXI	H,TRKMSG	; SET POINTER TO TRACK IMAGING START MESSAGE
	CALL	PRNTMSG
	LXI	H,FILENM	; IMAGE FILE NAME
	CALL	PRNTMSG
	LXI	H,OKMSG		; PROPMT USER FOR CONSENT TO BEGIN
	CALL	PRNTMSG
;
	CALL	CI		; GET CONSENT
	CPI	'Y'
	JNZ	ERR
	LXI	H,PROCMSG	; DISPLAY PROGRESS MESSAGE
	CALL	PRNTMSG
	OUT	DSKRST		; RESET THE SBC202 - 7FH RESETS DD FDC
;
DTRHI:	MVI	A,35H		; SETS DTR HIGH
	OUT	TTYC
	JMP	WRTCMD
;
DTRLO:	IN	TTYS		; SET USB FILE COMPLETE FLAG
	ANI	4
	JZ	DTRLO		; WAIT FOR TX EMPTY
	LXI	D,1000H
DTRLO0:				; GIVE THE USB A LITTLE TIME
	DCR	E
	JNZ	DTRLO0
	DCR	D
	JNZ	DTRLO0
;
	MVI	A,37H		; TOGGLE DTR AND USB SD0 LOW
	OUT	TTYC
	MVI	A,35H		; RETURN THEM TO HIGH
	OUT	TTYC
	RET			; TIME TO WRAP IT UP, DONE
;
WRTCMD:	LXI	H,WRTWRD	; SEND COMMAND TO USB
	CALL	TOUT
	LXI	H,FILENM+1	; GIVE IT FILENAME
	CALL	TOUT
	LXI	H,BINMSG	; USE THE B SWITCH FOR BINARY
	CALL	TOUT
	MVI	C,CR		; CR LAUNCH COMMAND
	CALL	TTYOUT
	JMP	TRKBYTRK	; NOW USB WANTS THE DATA
;
WRTWRD:	DB	'$WRITE ',0	; USB COMMAND 
BINMSG:	DB	' B',0		; BINARY TRANSFER MODE
;
TOUT:	MOV	A,M
	ORA	A
	RZ
	MOV	C,A
	CALL	TTYOUT
	INX	H
	JMP	TOUT
;
TTYIN:	IN	TTYS
	ANI	RRDY
	JZ	TTYIN
	IN	TTYI
	ANI	7FH
	RET
;
TTYOUT:	IN	TTYS
	ANI	TRDY
	JZ	TTYOUT
	MOV	A,C
	OUT	TTYO
	RET
;
TRKBYTRK:	
	MVI	A,0		; BEGIN WITH TRACK 0
	STA	TRACK
;
; BEGIN LOOP TO READ A TRACK FROM DISK, WRITE THE TRACK TO USB
;
TBT0:	CALL	SAYTRKN		; PRINTS THE TRACK#, BUT ESCAPES
				; TO DONE0 IF WE ARE ALREADY DONE
;
	LXI	H,TRKBUFF
	SHLD	IOPB5		; MAKE SURE IOPB HAS RIGHT BUFF ADDR
	LXI	H,IOPB		; LAUNCH THE FDC TO READ THE TRACK
	MOV	A,L
	OUT	LOWW
	MOV	A,H
	OUT	HI
;
TBT1:				; WAIT FOR DISK TO COMPLETE
	IN	078H		; READ STATUS FOR INTERRUPT PENDING
	ANI	4
	JZ	TBT1
	IN	DTYPE		; RESULT TYPE MUST ONLY BE READ AFTER BIT2
				; IN STATUS GOES TRUE, THEN MUST READ RSLT BYTE TOO
	ANI	2
	JZ	TYPE00
	LDA	OPCODE		; GET OPCODE FROM IOPB
	ANI	0F0H		; ISOLATE WHAT DRIVE IS BEING IMAGED
	MOV	B,A
	IN	DTYPE		; IT WAS TYPE 10
	ANA	B		; DRV MUST BE RDY TO READ FROM
	JZ	ERR
	JMP	OK
TYPE00:				; IS RESULT TYPE 00?
	IN	07BH		; RESULT BYTE
	ORA	A		; NOT 00000000B MEANS ERROR
	JNZ	ERR
OK:
	LXI	H,TRKBUFF
;
TBT2:				; EXPORT THE 6656 BYTES IN TRKBUFF
	MOV	C,M		; TO THE USB
	CALL	TTYOUT
	INX	H		; BUMP BUFF PTR
	LXI	D,BUFFTOP
	MOV	A,E
	CMP	L
	JNZ	TBT2
	MOV	A,D
	CMP	H
	JNZ	TBT2		; DONE WITH THIS TRACK?
	LDA	TRACK		; IF SO BUMP THE TRACK NUMBER
	INR	A
	STA	TRACK
	JMP	TBT0		; LOOP FOR NEXT TRACK
;
; THIS LOOUP TABLE IS A QUICK WAY NOT TO HAVE TO COMPUTE THE ASCII
; DECIMAL NUMBER FROM THE HEXADECIMAL TRACK VALUE BEING UPCOUNTED
; IN THE IOPB.
;
TRKNUM:	DB	'00010203040506070809'
	DB	'10111213141516171819'
	DB	'20212223242526272829'
	DB	'30313233343536373839'
	DB	'40414243444546474849'
	DB	'50515253545556575859'
	DB	'60616263646566676869'
	DB	'70717273747576??????'
;
TRKMSG:	DB	'UPLOADING DISK TRACK-BY-TRACK TO USB',0
;
OKMSG:	DB	', OK? Y/N',CR,LF,0
PROCMSG:	DB	'FINISHED IN TEN MINUTES...',CR,LF,0
;
TRKPTR:	DW	TRKNUM
;
SAYTRKN:MVI	C,CR		; WRITE OVER THE LAST UPDATE
	CALL	CO
	LDA	TRACK
	ADD	A		; DOUBLE IT
	LXI	H,TRKNUM	; INDEX INTO ASCII TABLE
	MOV	E,A
	MVI	D,0
	DAD	D
	MOV	C,M
	MVI	A,'?'		; REACHED THE END?
	CMP	C
	JZ	DONE0		; ABORT IF ? SEEN
	CALL	CO
	INX	H
	MOV	C,M
	CALL	CO
	INX	H
	SHLD	TRKPTR	; POINT TO NEXT ASCII PAIR
	RET
;
PRNTMSG:MOV	C,M
	CALL	CO
	INX	H
	MOV	A,M
	ORA	A
	JNZ	PRNTMSG
	RET
;
DONEMSG:DB	CR,LF,'DONE',CR,LF,0
;
DONE:	MVI	C,CLOSE
	LXI	D,CBLK
	CALL	ISIS
DONE0:
	CALL	DTRLO
	LXI	H,DONEMSG
	CALL	PRNTMSG
;
	MVI	C,EXIT
	LXI	D,XBLK
	CALL	ISIS
ERR:
	MVI	C,ERROR
	LXI	D,EBLK
	CALL	ISIS
	JMP	DONE0
;
	DSEG
OBLK:
	DW	WAFT
	DW	BUFFER
	DW	2
	DW	0
	DW	STATUS
;
CBLK:
CAFT:	DS	2
	DW	STATUS
;
RBLK:
OAFT:
RAFT:	DW	1
	DW	BUFFER
	DW	128
	DW	ACTUAL
	DW	STATUS
;
ACTUAL:	DS	2
;
WBLK:
WAFT:	DS	2
	DW	BUFFER
WCNT:	DS	2
	DW	STATUS
;
XBLK:	DW	STATUS
EBLK:
STATUS:	DS	2
		DW	STATUS
;
BUFFER:	DB	'NEW.IMG',0
	DS	120
;
FILENM:	DS	128
;
FIRSTNM:DS	2
DIGITS:	DS	1
BYTECNT:DS	2
;
RESPONSE:DS	128

;
IOPB:	DB	0		; INTERRUPTS ON
OPCODE:	DB	34H 		; UPPER NIBBLE DISK NUMBER LOWER NIBBLE OPCODE
	DB	52
TRACK:	DB	0
	DB	1
IOPB5:
	DW	TRKBUFF
;
	DS	128
;
TRKBUFF:DS	6656
;
BUFFTOP:
;
STCKA:	DS	4
;
END	IMAGER
;


