; INTEL MDS IMPORT FROM USB STICK UTILITY
; VER 1.0 NOV 12, 2016, RICHARD MAIN author
; VER 2.0 DEC 12, 2016, JACK MCMULLEN, REWRITE TO EXTEND FILE SIZE
; VER 2.1 DEC 18, 2017, CORRECTED CLOSE AFTN;
;
; PROGRAM SYNTAX IMPRTJ <DEVICE><FILENAME>
;
; PROGRAM REQUIRES:
; MDS-225: RICH'S MDS-USB board with its cable at USART socket A91 or 
; equivalent and the Hobbytronics USB Host Adapter board w/REV 1.14 firmware
; For other MDS systems remap defined ports herein.
; 62K MEMORY IS IDEAL
;
; THIS UTILITY WILL IMPORT FILES UP TO A MAX FILE SIZE OF
; 4912520 BYTES OR 3840 BLOCKS OF THE 3895 AVAIL ON 8" DD DATA DISK
; WITH ISIS 4.1 AS THE OS. ADDITIONAL HEADROOM IS LEFT SHOULD A LATER VERSION
; OF ISIS INCREASE IN SIZE
; IMPORTED FILES ARE READ IN SEGMENTS OF 32768 BYTES UNTIL COMPLETE
; INCREASING MAX BYTE SIZE IS POSSIBLE WITHIN BUT WAS NOT FOUND
; NECESSARY IN THIS VERSION
;
; THERE ARE TIME CRITICAL ROUTINES MAINLY TO KEEP UP WITH THE INBOUND DATA
; WHICH IS NOT THROTTLED RATHER FULL SPEED SEND REQUESTED SEGMENTS.
; ALSO SPECIFIC TIMEOUTS THAT WAIT FOR THE ARRIVAL OF DATA REQUESTED. 
; THE HOBBYTRONICS USB HOST ADAPTER TAKES LONGER RETURNING SEGMENTS THE 
; FURTHER INTO A LARGE FILE IS GOES.
;;
;
; GENERAL
;
CR	EQU	0DH
LF	EQU	0AH
;
; ISIS CALLS
;
OPEN	EQU	0
CLOSE	EQU	1
READ	EQU	3
WRITE	EQU	4
EXIT	EQU	9
ERROR	EQU	12
;
CRTI	EQU	0F6H		; MDS SERIAL CHANNEL 2
CRTO	EQU	0F6H
CRTS	EQU	0F7H
CRTC	EQU	0F7H
;
TTYI	EQU	0F4H		; MDS SERIAL CHAN 1, OBSOLETE TTY INTERFACE
TTYO	EQU	0F4H		; NOW THE HOST FOR THE USB INTERFACE
TTYS	EQU	0F5H
TTYC	EQU	0F5H
;
TRDY	EQU	00000001B
RRDY	EQU	00000010B
;
DTR	EQU	00000010B
;
	EXTRN	ISIS		; EXTERNAL REFERENCES TO ISIS-II SYSTEM
				; AND MDS CONSOLE
	EXTRN	CO
	EXTRN	CI
;
	CSEG
;
;
; SET THE TIMER CH0 AND TTY USART TO OPERATE AT 9600 BAUD
;
IMPRTJ:
	LXI	SP, STACKA	; INIT SP FOR THIS PROGRAM
	MVI	A, 40H		; RESET THE USART
	OUT	TTYC
	MVI	A, 036H		; SELECT COUNTER 0 , R/L LSB-MSB, SQ WV GEN
	OUT	0F3H		; MODE 3 AND LSB FOLLOWED BY MSB
	LXI	H, 08H		; FOR 9600 BAUD
	MOV	A, L
	OUT	0F0H		; SEND TO USART TIMER FOR TTY USART CH0
	MOV	A, H
	OUT	0F0H
	MVI	A, 0CEH		; MULTIPLIER FOR 9600 BAUD
	OUT	TTYC
	MVI	A, 25H		; ENABLE TX RX AND RTS
	OUT	TTYC
;
	MVI	A,35H		; PUT DTR AND SD0 USB HIGH
	OUT	TTYC
;
; TTY INTERFACE TO USB FLASHDRIVE READY TO GO AT 9600 BAUD
;
MSG:
	LXI	H,HELLO
MSG1:
	MOV	A,M
	ORA	A
	JZ	GETFN
	MOV	C,A
	CALL	CO		; MESSAGE TO CONSOLE OUTPUT
	INX	H		; POINT TO NEXT CHARACTER
	JMP	MSG1
;
;

GETFN:
	MVI	C,READ		; CALL ISIS TO READ THE COMMAND
	LXI	D,RBLK		; LINE TO BUFFER
	CALL	ISIS
	LDA	STATUS
	ORA	A
	JNZ	ERR
;
	LXI	H,BUFFER	; WE NEED A PRIVATE COPY OF <FILENAME>
	LXI	D,FILENM
	MVI	C,128
MOVEIT:
	MOV	A,M		; MOV CHAR FROM BUFFER
	CPI	':'
	CZ	BUMPH4		; CALL TO SCOOT H OVER BY 4 TO AVOID DEVICE
	INX	H		; INR PTR
	STAX	D		; PUT IN FILENM
	INX	D		; BUMP THAT PTR
MVIT0:
	MOV	A,M		; INSPECT WHAT WE'RE POINTING AT NOW
	CPI	20H		; A SPACE?
	JZ	ZERO		; IF SO, WE GOT THE WHOLE FILENAME
	CPI	CR		; A CR?
	JZ	ZERO		; IF SO, WE GOT IT
	DCR	C		; LIMIT TO 128 BYTES MOVED
	JZ	ZERO		; JUMP TO ZERO IF LIMIT
	JMP	MOVEIT		; OTHERWISE, MORE TO DO
;
ZERO:	MVI	A,0		; WE NEED A ZERO RIGHT AFTER <FILENAME>
	STAX	D		; D POINTS TO WHERE TO PUT THE 0
;
OPENFL:				; OPEN THE WRITE FILE THE USER WANTED
				; THIS GETS THE AFT FOR THE TEXT NAME
	MVI	C,OPEN
	LXI	D,OBLK
	CALL	ISIS		; THIS PUT THE AFTN IN WAFT IN WBLK
	LDA	STATUS
	ORA	A
	JNZ	ERR
	LHLD	WAFT		; GET CURRENT AFT
	SHLD	CAFT		; COPY IT TO THE CLOSE AFT
	JMP	LAUNCH		; READY NOW TO READ THE DATA FROM USB
;
; NAME OF FILE IS IN BUFFER
;
READFL:
	MVI	C,READ
	LXI	D,RBLK
	CALL	ISIS
	LDA	STATUS
	ORA	A
	JNZ	ERR
	JMP	LAUNCH		; CLEAN USART THE ISSUE COMMAND WITH <FILENAME>
;
BUMPH4:	INX	H
	INX	H
	INX	H
	INX	H
	MOV	A,M
	RET
;
LAUNCH:
	CALL	TELL		; INFORM WHAT SEGMENT WE'RE DOING
	LXI	H, RDCMD	; POINT TO USB COMMAND
LNCH0:
	MOV	C,M		; SEND CMMD TO USB
	CALL	TTYOUT
	INX	H		; IS NEXT A 0?
	MOV	A,M
	CPI	0
	JNZ	LNCH0		; IF ZERO, NOW SEND <FILENAME>
;
	LXI	H,FILENM	; NOW THE FILENAME
LNCH1:
	MOV	C,M		; SEND <FILENAME>
	CALL	TTYOUT
	INX	H
	MOV	A,M
	CPI	0		; END MARKER 0?
	JNZ	LNCH1
	LDA	SEGCNT		; CASE OF SEGMENT NUMBER
	CPI	1		; FIRST
	LXI	H,SEG1
	JZ	LNCH2
	CPI	2		; SECOND
	LXI	H,SEG2
	JZ	LNCH2
	CPI	3		; THIRDS
	LXI	H,SEG3
	JZ	LNCH2
	CPI	4		; FORTH
	LXI	H,SEG4
	JZ	LNCH2
	CPI	5		; FIFTH
	LXI	H,SEG5
	JZ	LNCH2
	CPI	6		; SIXTHD
	LXI	H,SEG6
	JZ	LNCH2
	CPI	7		; SEVENTH
	LXI	H,SEG7
	JZ	LNCH2
	CPI	8		; EIGTH
	LXI	H,SEG8
	JZ	LNCH2
	CPI	9		; NINTH
	LXI	H,SEG9
	JZ	LNCH2
	CPI	10		; TENTH
	LXI	H,SEG10
	JZ	LNCH2
	CPI	11		; ELEVENTH
	LXI	H,SEG11
	JZ	LNCH2
	CPI	12		; TWELFTH
	LXI	H,SEG12
	JZ	LNCH2
	CPI	13		; THIRTEENTH
	LXI	H,SEG13
	JZ	LNCH2
	CPI	14		; FOURTEENTH
	LXI	H, SEG14
	JZ	LNCH2
	CPI	15		; FIFTEENTH AND MAX FILE SIZE
	LXI	H, SEG15
;
LNCH2:
	MOV	C, M
	CALL	TTYOUT
	INX	H
	MOV	A, M
	CPI	0
	JNZ	LNCH2
	MVI	C, CR		; GIVE USB COMMAND
	CALL	TTYOUT
;
	LXI	H, DATBUFF	; WHERE USB HAS TO BUFFER IN DATA
	MVI	C, 0FFH		; INIT HSB OF WAIT TIME OUT CNTR
	LXI	D, 0FFFFH	; INIT MSB & LSB OF TIMEOUT COUNTER
L0:				; USED TO COMPENSATE FOR VARIABLE TIME THAT USB
				; TAKES TO RETURN DATA
	IN	TTYS
	ANI	RRDY
	JNZ	LBCZ		; DATA READY? YES BRING IN DATA
	DCX	D
	MOV	A,E
	ORA	D
	JNZ	L0
	LXI	D,0FFFFH
	DCR	C
	JZ 	TIMOUT
	JMP	L0		; NOPE KEEP LOOKING

L1:
	IN	TTYS
	ANI	RRDY
	JNZ	L2
	DCX	D		; COUNT DOWN TIME OUT
	MOV	A,D
	ORA	E		; BC BOTH DOWN TO ZERO?
	JZ	TRIM		; TIME OUT ESCAPE TRAP
	JMP	L1		; LOOP WITHOUT RESETING
;
LBCZ:	LXI	B,0		; INITIALIZE BYTE COUNTER TO ZERO
L2:
	IN	TTYI
	MOV	M,A		; WRITE IT TO DATBUFF
	INX	H		; BUMP POINTER
	INX	B		; BUMP COUNT
	LXI	D,0FFFFH
	JMP	L1		; RESET THE TIME OUT
;
TRIM:	
	MOV	A,C		; TEST FOR 0 BYTE COUNT RECVD, YES WE'RE DONE
	ORA	B		; OTHERWISE WRITE THE SEGMENT
	JZ	DONE
;
; NOW WRITE TO DISK
;	
WRTDSK:
	PUSH	B
	MOV	A,B
	ANI	80H		; TEST FOR LESS THAN FULL BUFFER
	JNZ	WR1		; FULL BUFF
	MVI	A,0FFH
	STA	PARTL		; SET PARTIAL FLAG
WR1:
	POP	H
	SHLD	WCNT		; SET BYTE TO WRITE
	MVI	C,WRITE		; DO THE MAX WRITE DISK
	LXI	D,WBLK
	CALL	ISIS
	LDA	STATUS
	ORA	A
	JNZ	ERR
	LDA	PARTL		; TEST IF LESS THAN A FULL BUFFER
	ORA	A		; SET THE FLAGS
	JNZ	DONE		; IF NOT ZERO SHOULD BE DONE
				; IF NOT DO ANOTHER SEGMENT
NXTSEG:
	LDA	SEGCNT		; GET CURRENT SEGMENT COUNT
	INR	A		; BUMP, SAVE AND GO DO IT
	CPI	16		; 4912520 BYTES-ABSOLUTE MAX FILE SIZE
	JZ 	DONE		; MAX FILE SIZE REACHED
	STA	SEGCNT
	JMP	LAUNCH
;
TTYOUT:				; WRITES A CHAR TO THE TTY USART AND THE USB
	IN	TTYS
	ANI	TRDY
	JZ	TTYOUT
	MOV	A,C
	OUT	TTYO
	RET
;
TTYIN:				; READS A CHAR FROM THE USB THROUGH TTY USART
	IN	TTYS
	ANI	RRDY
	JZ	TTYIN
	IN	TTYI
	RET
;
TIMOUT:				; SEND TIME OUT OF USB
	LXI	H,TMOUT
TMO1:	MOV	C,M
	CALL	CO
	INX	H
	MOV	A,M
	CPI	0
	JNZ	TMO1
;
DONE:	MVI	C,CLOSE
	LXI	D,CBLK
	CALL	ISIS
DONE0:
	MVI	C,CR
	CALL	CO
	MVI	C,LF
	CALL	CO
	MVI	C,EXIT
	LXI	D,XBLK
	CALL	ISIS
				; GONE TO ISIS
;
ERR:
	LXI	H, ERRMSG	; FLAG ERROR TO CONSOLE
ERR0:	MOV	A,M
	ORA	A
	JZ	ERR1
	MOV	C,A
	CALL	CO
	INX	H
	JMP	ERR0
;
ERR1:
	MVI	C, ERROR
	LXI	D, EBLK
	CALL	ISIS
	LXI	H, ERROR
	JMP	DONE0
;
TELL:				; DECIMALIZES SEGMENT COUNT FOR DISPLAY
	XRA	A		; CLEAR ALL FLAGS FOR DAA
	LDA	SEGCNT		; GET CURRENT SEGMENT COUNT
	DAA			; MAKE DECIMAL
	PUSH	PSW		; SAVE A COPY
	ANI	0FH		; ISOLATE LSD
	ADI	30H		; MAKE IT ASCII
	STA	SEGNUM +1	; PLACE IT
	POP	PSW		; GET THE COPY BACK
	ANI	0F0H		; ISOLATE THE MSD
	RAR			; POSITION IN LOWER NIBBLE
	RAR
	RAR
	RAR
	ADI	30H		; MAKE IT ASCII
	STA	SEGNUM		; PLACE IT
	LXI	H, SEGMSG	; DISPLAY MESSAGE
TELL0:	MOV	C,M		; SEND CMMD TO USB
	CALL	CO
	INX	H		; IS NEXT A 0?
	MOV	A,M
	CPI	0
	JNZ	TELL0		; TELL WHAT SEGMENT WE'RE DOING
	RET
;
;
DSEG
;
RDCMD:	DB	'$READ ',0	; STRING USB NEEDS FOR TYPE CMD
SEG1:	DB	' 0 32768',0
SEG2:	DB	' 32768 32768',0
SEG3:	DB	' 65536 32768',0
SEG4:	DB	' 98304 32768',0
SEG5:	DB	' 131072 32768',0
SEG6:	DB	' 163840 32768',0
SEG7:	DB	' 196608 32768',0
SEG8:	DB	' 229376 32768',0
SEG9:	DB	' 262144 32768',0
SEG10:	DB	' 294912 32768',0
SEG11:	DB	' 327680 32768',0
SEG12:	DB	' 360448 32768',0
SEG13:	DB	' 393216 32768',0
SEG14:	DB	' 425984 32768',0
SEG15:	DB	' 458752 32768',0
;SEG16:	DB	' 491520 32768',0
PARTL:	DB	0		; PARTIAL BUFFER FILL FLAG
SEGCNT:	DB	1
;
HELLO:	DB	CR,LF,'USB TO MSD FILE IMPORT UTILITY, V2.1'
	DB	CR,LF,' IMPRTJ <:Fx:filename>',CR,LF
	DB	'MAX FILE 4912520 BYTES'
	DB	' 3840 BLKS'
	DB	CR,LF,CR,LF,0
TMOUT:	DB	'TIMOUT ERROR WAITING FOR USB DATA',CR,LF,0
ERRMSG:	DB	'ISIS ERROR ENCOUNTERED, EXITING',CR,LF,0
SEGMSG:	DB	'IMPORTING SEGMENT '
SEGNUM:	DB	30H,30H,CR,LF,0
;
OBLK:
	DW	WAFT
	DW	BUFFER
	DW	2		; 2, FILE IS OPENED FOR OUTPUT(WRITE)
	DW	0
	DW	STATUS
;
CBLK:
CAFT:	DW	WAFT		; WE CLOSE WHAT WE OPENED, WAS ONLY 1
	DW	STATUS
;
RBLK:
OAFT:
RAFT:	DW	1		; OPEN PUTS THE AFT HERE FOR READ OPS
RDPTR:	DW	BUFFER		; WHERE TO PUT READ DATA
	DW	512		; READS WILL GET 4 BLOCKS, 512 BYTES
	DW	ACTUAL
	DW	STATUS
;
ACTUAL:	DS	2
;
WBLK:				
WAFT:	DS	2
	DW	DATBUFF		; WHERE TO GET THE DATA TO WRITE
WCNT:	DW	0000		; SET BY CODE TO SIZE OF DATA RECEIVED
	DW	STATUS
;
XBLK:	DW	STATUS
EBLK:
STATUS:	DS	2
	DW	STATUS
;
BUFFER:	DS	512
;
FILENM:	DS	128
;
	DS	10
STACKA	EQU	$
;
DATBUFF:DS	38400		; USB DATA IMPORT BUFFER
;
END		IMPRTJ
;
